# Frontend Development Guidelines

This guide contains all the information to successfully contribute to GitLab's frontend.
This is a living document, and we welcome contributions, feedback and suggestions.

## [Principles](principles.md)

Ensure that your frontend contribution starts off in the right direction.

## [Initiatives](initiatives.md)

High level overview of where we are going from a frontend perspective.

## [Development](development/index.md)

Guidance on topics related to development.

## [Dependencies](dependencies.md)

Learn about all the dependencies that make up our frontend, including some of our own custom built libraries.

## [Style](style/index.md)

Style guides to keep our code consistent.

## [Tips](tips.md)

Tips from our frontend team to develop more efficiently and effectively.
